unit clip;

{$IFDEF FPC}{$mode objfpc}{$H+}{$ENDIF}

interface

uses
{$IFDEF FPC}LResources,  {$ENDIF}
  Classes, SysUtils,  Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls;

type

  { TClipForm }

  TClipForm = class(TForm)
    ClipTrack: TTrackBar;
    AziTrack: TTrackBar;
    ElevTrack: TTrackBar;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;

    procedure ClipTrackChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AziTrackChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  ClipForm: TClipForm;

implementation
uses mainunit;
{ TClipForm }
{$IFNDEF FPC} {$R *.dfm}   {$ENDIF}

procedure TClipForm.ClipTrackChange(Sender: TObject);
begin
  if ClipForm.Visible then
    GLForm1.SetViewerClipPlane(ClipTrack.position);
end; //proc ClipTrackChange

procedure TClipForm.FormShow(Sender: TObject);
begin
  if ClipTrack.Tag = 0 then begin//set default value if the first time this window is opened
    ClipTrack.position := 300;
    ClipTrack.Tag := 1; //use users settings in future
  end; //if 1st time
end; //proc FormShow


procedure TClipForm.AziTrackChange(Sender: TObject);
begin
  if not ClipForm.Visible then
    exit;
  GLForm1.SetViewerClipPlaneAE (ClipTrack.position,AziTrack.Position,ElevTrack.position);
  Caption := 'A='+inttostr(AziTrack.Position)+'  E='+inttostr(ElevTrack.Position)+' Slice='+inttostr(ClipTrack.position);
end;

initialization
{$IFDEF FPC}
  {$I clip.lrs}
{$ENDIF}
end.

