unit scriptengine;
{$include options.inc}
interface
{$IFDEF FPC}{$mode DELPHI}{$H+}{$ENDIF}
uses
{$IFDEF FPC}LResources,
{$ELSE} //Delphi
  {$IFDEF ENABLEAVI} GLAVIRecorder, {$ENDIF}

{$ENDIF}
{$IFDEF Unix} LCLIntf,{$ELSE} Windows,{$ENDIF}

   scaleimageintensity,ClipBrd, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,   GLScene, define_types, Menus,
  //uPSCompiler,uPSRuntime,Messages,
  uPSComponent;

type

  { TScriptForm }
  TScriptForm = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    clipazimuthelevation1: TMenuItem;
    PSScript1: TPSScript;
    Splitter1: TSplitter;
    ScriptMenu1: TMainMenu;
    Toosl1: TMenuItem;
    Compile1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    Stop1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Insert1: TMenuItem;
    Render1: TMenuItem;
    Mosaic1: TMenuItem;
    Contrast1: TMenuItem;
    Forms1: TMenuItem;
    SCRIPTFORMVISIBLE1: TMenuItem;
    CONTRASTFORMVISIBLE1: TMenuItem;
    CUTOUTFORMVISIBLE1: TMenuItem;
    CLIPFORMVISIBLE1: TMenuItem;
    MOSAICFORMVISIBLE1: TMenuItem;
    WAIT1: TMenuItem;
    loadimage1: TMenuItem;
    savebmp1: TMenuItem;
    Sliceviews1: TMenuItem;
    orthoview1: TMenuItem;
    Clip1: TMenuItem;
    backcolor1: TMenuItem;
    cameradistance1: TMenuItem;
    azimuth1: TMenuItem;
    elevation1: TMenuItem;
    cutout1: TMenuItem;
    maximumintensity1: TMenuItem;
    viewaxial1: TMenuItem;
    viewcoronal1: TMenuItem;
    viewsagittal1: TMenuItem;
    framevisible1: TMenuItem;
    setcolortable1: TMenuItem;
    CHANGENODE1: TMenuItem;
    addnode1: TMenuItem;
    contrastminmax1: TMenuItem;
    azimuthelevation1: TMenuItem;
    Dialogs1: TMenuItem;
    modalmessage1: TMenuItem;
    modelessmessage1: TMenuItem;
    Overlays1: TMenuItem;
    OverlayLoad1: TMenuItem;
    overlaycloseall1: TMenuItem;
    overlaycolornumber1: TMenuItem;
    overlaycolorname1: TMenuItem;
    overlayminmax1: TMenuItem;
    overlaytransparencybackground1: TMenuItem;
    overlaytransparencyoverlay1: TMenuItem;
        overlaycolorfromzero1: TMenuItem;
    overlayformvisible1: TMenuItem;
    perspective1: TMenuItem;
    colorname1: TMenuItem;
    colorbarvisible1: TMenuItem;
    Colorbar1: TMenuItem;
    colorbarcoord1: TMenuItem;
    colorbartext1: TMenuItem;
    SliceText1: TMenuItem;
    overlayloadsmooth1: TMenuItem;
    colorbarformvisible1: TMenuItem;
    edgedetect1: TMenuItem;
    overlaymaskedbybackground1: TMenuItem;
    resetdefaults1: TMenuItem;

    procedure  Readline(var lPosIn: integer);
    procedure Compile1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure OpenScript(lFilename: string);
    procedure Memo1Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Stop1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure OpenMRU(Sender: TObject);//open template or MRU
    procedure UpdateMRU;
    procedure InsertCommand(Sender: TObject);
    procedure AdjustSelText;
    procedure PSScript1Compile(Sender: TPSScript);
    procedure Writeln(Str: string);
procedure AZIMUTH (DEG: integer);
procedure AZIMUTHELEVATION (AZI, ELEV: integer);
procedure BACKCOLOR (R,G,B: byte);
procedure CAMERADISTANCE (Z: single);
procedure CHANGENODE(INDEX, INTENSITY, R,G,B,A: byte);
procedure CLIP (DEPTH: single);
procedure CLIPAZIMUTHELEVATION (DEPTH,AZI,ELEV: single);
procedure CLIPFORMVISIBLE (VISIBLE: boolean);
procedure COLORBARCOORD (L,T,R,B: single);
procedure ADDNODE(INTENSITY, R,G,B,A: byte);
procedure COLORBARFORMVISIBLE (VISIBLE: boolean);
procedure COLORBARTEXT (VISIBLE: boolean);
procedure COLORBARVISIBLE (VISIBLE: boolean);
procedure COLORNAME(Filename: string);
procedure CONTRASTFORMVISIBLE (VISIBLE: boolean);
procedure CONTRASTMINMAX(MIN,MAX: single);
procedure CUTOUT (L,A,S,R,P,I: single);
procedure CUTOUTFORMVISIBLE (VISIBLE: boolean);
procedure EDGEDETECT (lThresh: single; lDilateCycles: integer);//new
procedure MEDIANSMOOTH;//new
procedure DECIMATE (lPercent: integer);
procedure ELEVATION (DEG: integer);
procedure FRAMEVISIBLE (VISIBLE: boolean);
procedure LOADIMAGE(lFilename: string);
procedure MAXIMUMINTENSITY (MIP_ON: boolean);
procedure MODALMESSAGE(STR: string);
function MODALMESSAGEX(STR: string): boolean;
procedure MODELESSMESSAGE(STR: string);
procedure MOSAIC(Str: string);
procedure MOSAICFORMVISIBLE (VISIBLE: boolean);
procedure ORTHOVIEW (X,Y,Z: single);
procedure OVERLAYCLOSEALL;
procedure OVERLAYCOLORNAME(lOverlay: integer; lFilename: string);
procedure OVERLAYCOLORNUMBER(lOverlay,lLUTIndex: integer);
procedure OVERLAYFORMVISIBLE (VISIBLE: boolean);
procedure OVERLAYLOADSMOOTH (SMOOTH: boolean);
function OVERLAYLOAD(lFilename: string): integer;
procedure LOADDTI(lFAFilename: string);
procedure OVERLAYCOLORFROMZERO (FROMZERO: boolean);
procedure OVERLAYMASKEDBYBACKGROUND (MASK: boolean); //new
//procedure OVERLAYMINMAX (lOverlay,lMin,lMax: double);
procedure OVERLAYMINMAX (lOverlay: integer; lMin,lMax: single);
procedure OVERLAYTRANSPARENCYONBACKGROUND(lPct: integer);
procedure OVERLAYTRANSPARENCYONOVERLAY(lPct: integer);
procedure PERSPECTIVE (USEPERSPECTIVE: boolean);
procedure RESETDEFAULTS;
procedure SAVEBMP(lFilename: string);
procedure SCRIPTFORMVISIBLE (VISIBLE: boolean);
procedure SETCOLORTABLE(TABLENUM: integer);
procedure SLICETEXT (VISIBLE: boolean);
procedure VIDEOSTART (lFilename: string; lFPS: integer; lDefaultCodec: boolean);
procedure VIDEOCAPTUREFRAME;
procedure VIDEOEND;
procedure VIEWAXIAL (STD: boolean);
procedure VIEWCORONAL (STD: boolean);
procedure VIEWSAGITTAL (STD: boolean);
procedure WAIT(MSEC: integer);
  private
    fn: string;
    gchanged: Boolean;
    function SaveTest: Boolean;
  public
    { Public declarations }
  end;
const
  kScriptExt = '.gls';
 kScriptFilter = 'NIfTI ('+kScriptExt+')|'+kScriptExt;

var
  ScriptForm: TScriptForm;

implementation
uses
    mainunit,userdir,
  clutprefs, cutout, clip, mosaicprefs,prefs,clut, overlay,colorbar,
  messageu;
{$IFNDEF FPC}
{$R *.DFM}
{$ENDIF}


procedure FinishRender;
begin
    repeat
      application.ProcessMessages;
      //application.HandleMessage;
    until (not gRendering) and (not GLForm1.Timer.Enabled) and (not GLForm1.UpdateTimer.Enabled);
end;

procedure TScriptForm.Writeln(Str: string);
begin
  ScriptForm.Memo2.lines.add(Str);
end;

function ScriptDir: string;
begin
  result := AppDir+'script'
end;

procedure TScriptForm.OpenMRU(Sender: TObject);//open template or MRU
//Templates have tag set to 0, Most-Recently-Used items have tag set to position in gMRUstr
begin
  if Sender = nil then begin
    if (gPrefs.PrevScriptName[1] <> '') and (Fileexists(gPrefs.PrevScriptName[1])) then
      OpenScript (gPrefs.PrevScriptName[1]);
  end else
    OpenScript (gPrefs.PrevScriptName[(Sender as TMenuItem).tag]);
end;

procedure TScriptForm.UpdateMRU;//most-recently-used menu
var
  NewItem: TMenuItem;
	lPos,lN : integer;
begin
  While File1.Count > 6 do File1.Items[6].Free;
  lN := 0;
  for lPos := 1 to knMRU do begin//for each MRU
      if gPrefs.PrevScriptName[lPos] <> '' then begin
		   inc(lN);
		   NewItem := TMenuItem.Create(Self);
		   NewItem.Caption :=ExtractFileName(gPrefs.PrevScriptName[lPos]);//(ParseFileName(ExtractFileName(lFName)));
		   NewItem.Tag := lN;
                   {$IFDEF FPC}
                    NewItem.onclick :=  OpenMRU; //Lazarus
                    {$ELSE}
                     NewItem.onclick :=  OpenMRU;
                     {$ENDIF}
		   //NewItem.ShortCut := ShortCut(Word('1')+ord(lN-1), [ssCtrl]);
		   File1.Add(NewItem);
      end;//if mru exists
  end;//for each MRU
end;  //UpdateMRU

procedure view3D;
begin
  if gPrefs.OrthoSliceView then
    FinishRender;
  {$IFDEF Darwin}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
   GLForm1.SetView(false,false);
   {$ELSE}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
 GLForm1.SetView(false,true);
 {$ENDIF}
 //GLForm1.OrthoSliceViewMenuClick(nil);
end;

procedure TScriptForm.WAIT (MSEC: integer);
var
lEND : DWord;
begin
  lEND := GetTickCount+MSEC;
  FinishRender;//June 09
  repeat
    Application.ProcessMessages;//HandleMessage
  until GetTickCount >= lEnd;
end;


procedure view2D;
begin
//if not gPrefs.OrthoSliceView then
  FinishRender;
  {$IFDEF Darwin}
GLForm1.SetView(true,false);
{$ELSE}
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
 GLForm1.SetView(true,true);
{$ENDIF}
end;

procedure viewXD;
begin
{$IFDEF Darwin}
GLForm1.SetView(gPrefs.OrthoSliceView,false);
{$ELSE}
 GLForm1.SetView(gPrefs.OrthoSliceView,true);
{$ENDIF}
end;

procedure TScriptForm.RESETDEFAULTS;
begin
    SetDefaultPrefs(gPrefs,false);
    GLForm1.DisplayPrefs(gPrefs);
end;
function TScriptForm.OVERLAYLOAD(lFilename: string): integer;
begin
  result := OverlayForm.AddOverlay(lFilename,1);
end;

function ChangeEnd (lInStr,lNewEnd: string): string;
// filename_FA,V1 will return Filename_V1
var
  lLenStr,lLenEnd,lI: integer;
begin
  result := '';
  lLenStr := length(lInStr);
  lLenEnd := length(lNewEnd);
  if lLenStr < lLenEnd then
    exit;
  result := lInStr;
  if lLenEnd < 1 then
    exit;
  for lI := 1 to lLenEnd do
    result[lLenStr-lLenEnd+lI] := lNewEnd[lI];
end;

procedure TScriptForm.LOADIMAGE(lFilename: string);
begin
    GLForm1.LoadDatasetNIFTI(lFileName,false);
end;

procedure TScriptForm.LOADDTI(lFAFilename: string);
var
  lPath,lName,lExt,lV1: string;
begin
  GLForm1.LoadDatasetNIFTI(lFAFilename,false);
  FilenameParts (gPrefs.PrevFilename[1]{lFAFilename}, lPath,lName,lExt);
  lV1 := ChangeEnd (lPath+lName,'V1')+lExt;
  if not Fileexists(lV1) then
    showmessage('Unable to find FSL vector named '+lV1);
  {$IFDEF ENABLEOVERLAY}
  //LoadDTI('C:\pas\mricrogl\source\dti_corr_fit_FA.nii.gz','C:\pas\mricrogl\source\dti_corr_fit_V1.nii.gz');
  OverlayForm.Addoverlay(lV1,1);
  OverlayForm.Addoverlay(lV1,2);
  OverlayForm.Addoverlay(lV1,3);
  AbsImgIntensity32(gOverlayImg[1] );
  AbsImgIntensity32(gOverlayImg[2] );
  AbsImgIntensity32(gOverlayImg[3] );
  OverlayForm.UpdateImageIntensityMinMax (1, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (2, 0,1);
  OverlayForm.UpdateImageIntensityMinMax (3, 0,1);
  OVERLAYTRANSPARENCYONBACKGROUND(-2);//modulate
  OVERLAYTRANSPARENCYONOVERLAY(-1);//additive
  {$ENDIF}
end;

procedure TScriptForm.OVERLAYCLOSEALL;
begin
  OverlayForm.Closeoverlays1Click(nil);
end;

procedure TScriptForm.OVERLAYCOLORNUMBER(lOverlay,lLUTIndex: integer);
begin
  OverlayForm.UpdateLUT(lOverlay,lLUTIndex,true);
  OverlayForm.ChangeOverlayUpdate;
end;

procedure TScriptForm.OVERLAYCOLORNAME(lOverlay: integer; lFilename: string);
var
  lLUTIndex: integer;
begin
  SetItemNameX (lFilename, OverlayForm.LUTDrop);
  lLUTIndex :=  OverlayForm.LUTDrop.ItemIndex;
  OverlayForm.UpdateLUT(lOverlay,lLUTIndex,true);
  OverlayForm.ChangeOverlayUpdate;
end;

//procedure TScriptForm.OVERLAYMINMAX (lOverlay,lA,lMin,lMax: double);
procedure TScriptForm.OVERLAYMINMAX (lOverlay: integer; lMin,lMax: single);
begin
OverlayForm.UpdateImageIntensityMinMax (lOverlay, lMin,lMax);
end;

procedure TScriptForm.OVERLAYTRANSPARENCYONBACKGROUND(lPct: integer);
begin
  gPrefs.BackgroundAlpha := lPct;
  OverlayForm.StatusPanelUpdate;
  OverlayForm.ChangeOverlayUpdate;
  OverlayForm.SetSubmenuWithTag(OverlayForm.Onbackground1,gPrefs.BackgroundAlpha);
end;

procedure TScriptForm.OVERLAYTRANSPARENCYONOVERLAY(lPct: integer);
begin
  gPrefs.OverlayAlpha := lPct;
  OverlayForm.StatusPanelUpdate;
  OverlayForm.ChangeOverlayUpdate;
  OverlayForm.SetSubmenuWithTag(OverlayForm.Onotheroverlays1,gPrefs.OverlayAlpha);
end;

procedure TScriptForm.OVERLAYLOADSMOOTH (SMOOTH: boolean);
begin
  gPrefs.InterpolateOverlays := SMOOTH;
  OverlayForm.InterpolateMenu.Checked := SMOOTH;
end;

procedure TScriptForm.OVERLAYMASKEDBYBACKGROUND (MASK: boolean);
begin
    gPrefs.MaskOverlayWithBackground := Mask;
    OverlayForm.BackgroundMaskMenu.Checked := Mask;
end;

procedure TScriptForm.OVERLAYCOLORFROMZERO (FROMZERO: boolean);
begin
    gPrefs.OverlayColorFromZero := FROMZERO;
    OverlayForm.OverlayColorFromZeroMenu.Checked := FROMZERO;
    OverlayForm.OverlayColorFromZeroMenuClick(nil);
end;

procedure TScriptForm.MOSAIC(Str: string);
begin
    GLForm1.DrawMosaic(Str);
end;

procedure TScriptForm.SAVEBMP(lFilename: string);
var
  lF,lExt: string;
begin
  FinishRender;
  lF := lFilename;
  lExt := UpCaseExt(lF);
  if (lExt <> '.JPG') and (lExt <> '.PNG')  then
        lF := lF + '.jpg';
  EnsureDirExists(lF);
  GLForm1.SavePicture(lF);
end;


function MESSAGEX(STR: string): boolean;
begin
    result := false;
    MessageForm.CaptionLabel.Caption := Str;
    MessageForm.showmodal;
    repeat
        application.HandleMessage;
    until MessageForm.ModalResult = mrOK;
    result := true;
end;

procedure TScriptForm.MODALMESSAGE(STR: string);
begin
  if not MESSAGEX(STR) then
    showmessage('Error');
end;

function TScriptForm.MODALMESSAGEX(STR: string): boolean;
begin
  result := MESSAGEX(STR);
end;

procedure TScriptForm.MODELESSMESSAGE(STR: string);
begin
    GLForm1.GLHUDText1.text := (STR);
end;

procedure TScriptForm.SLICETEXT (VISIBLE: boolean);
begin
  gPrefs.SLICEText := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
  //GLForm1.ColorBarMenuClick(nil);
end;

procedure TScriptForm.COLORBARTEXT (VISIBLE: boolean);
begin
  gPrefs.ColorBarText := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
  //GLForm1.ColorBarMenuClick(nil);
end;

procedure TScriptForm.COLORBARVISIBLE (VISIBLE: boolean);
begin
  gPrefs.ColorBar := VISIBLE;
  GLForm1.UpdateTimer.enabled := true;
  //GLForm1.ColorBarMenuClick(nil);
end;

procedure TScriptForm.COLORBARCOORD (L,T,R,B: single);
begin
  gPrefs.ColorBarPos:= CreateUnitRect (L,T,R,B);
  SensibleUnitRect(gPrefs.ColorBarPos);
  GLForm1.UpdateTimer.Enabled := true;
end;

procedure TScriptForm.MEDIANSMOOTH;
begin
  GLForm1.MedianSmoothing;
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure TScriptForm.EDGEDETECT (lThresh: single; lDilateCycles: integer);
begin
  GLForm1.Edgedetection(lThresh,lDilateCycles);
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure TScriptForm.DECIMATE (lPercent: integer);
begin
  GLForm1.DecimateV(lPercent);
  {$IFDEF Darwin}
  view3D;
  {$ENDIF}
end;

procedure TScriptForm.OVERLAYFORMVISIBLE (VISIBLE: boolean);
begin
  GLForm1.Overlays1Click(nil);
  OverlayForm.visible := VISIBLE;
end;

procedure TScriptForm.SCRIPTFORMVISIBLE (VISIBLE: boolean);
begin
  GLForm1.Scripting1Click(nil);
  ScriptForm.visible := VISIBLE;
end;

procedure TScriptForm.CONTRASTFORMVISIBLE (VISIBLE: boolean);
begin
  GLFOrm1.Colorandtransarency1Click(nil);
  CLUTForm.visible := VISIBLE;
end;

procedure TScriptForm.COLORBARFORMVISIBLE (VISIBLE: boolean);
begin
  GLFOrm1.ColorbarFormMenuClick(nil);
  ColorbarForm.visible := VISIBLE;
end;

procedure TScriptForm.CUTOUTFORMVISIBLE (VISIBLE: boolean);
begin
  GLForm1.AdjustFormPos(TFOrm(CutOutForm));
  CutOutForm.visible := VISIBLE;
end;

procedure TScriptForm.CLIPFORMVISIBLE (VISIBLE: boolean);
begin
  GLForm1.AdjustFormPos(TFOrm(CLIPForm));
  CLIPForm.visible := VISIBLE;
end;

procedure TScriptForm.MOSAICFORMVISIBLE (VISIBLE: boolean);
begin
  MosaicPrefsForm.visible := VISIBLE;
end;


procedure TScriptForm.AZIMUTH (DEG: integer);
begin
  view3D;
  GLForm1.GLCamera1.MoveAroundTarget (0,DEG);
end;

procedure TScriptForm.ELEVATION (DEG: integer);
begin
  view3D;
  GLForm1.GLCamera1.MoveAroundTarget (DEG,0);
end;

procedure TScriptForm.AZIMUTHELEVATION (AZI, ELEV: integer);
begin
  view3D;
  GLForm1.Camera2AzimuthElevationDeg(AZI,ELEV);
end;

procedure TScriptForm.CAMERADISTANCE (Z: single);
begin
  GLForm1.ViewingDistance(Z);
  //GLForm1.Zoom (-Z);
end;

procedure TScriptForm.COLORNAME(Filename: string);
begin
  SetItemNameX (Filename, CLUTForm.LUTDrop);
  //CLUTForm.LUTDrop.ItemIndex := TABLENUM;
  CLUTFOrm.LUTDropChange (nil);
end;

procedure TScriptForm.SETCOLORTABLE(TABLENUM: integer);
begin
  CLUTForm.LUTDrop.ItemIndex := TABLENUM;
  CLUTFOrm.LUTDropChange (nil);
end;

procedure RenderUpdate;
begin
   CLUTForm.DrawCLUTa(gCLUTrec);
   GLForm1.M_Refresh := TRUE;
   GLForm1.GLSceneViewer1.invalidate;
end;

procedure TScriptForm.CHANGENODE(INDEX, INTENSITY, R,G,B,A: byte);
var
  lNode,lI: integer;
begin
  lNode := INDEX;
  if lNode < 0 then
    lNode := 0;
  if lNode > (gCLUTrec.numnodes-1) then
    lNode := gCLUTrec.numnodes-1;
  lI := INTENSITY;
  //window spans from zero to 255, so bounding nodes must be in this range....
  if lNode = 0 then
    lI := 0;
  if lNode = (gCLUTrec.numnodes-1) then
    lI := 255;
  //we need to keep the nodes in order...
  if (lNode > 0) and (lI <= gCLUTrec.nodes[lNode-1].intensity) then
    lI := gCLUTrec.nodes[lNode-1].intensity + 1;
  if (lNode < (gCLUTrec.numnodes-1)) and (lI >= gCLUTrec.nodes[lNode+1].intensity) then
    lI := gCLUTrec.nodes[lNode-1].intensity - 1;
  gCLUTrec.nodes[lNode] := node(lI, R,G,B,A);

  //GLForm1.CLUTTimerXOn;
  //CLUTFOrm.DrawCLUTa(gCLUTrec);
 //GLForm1.ApplyCTContrast;
 // GLForm1.CLUTTimerXOn;
 RenderUpdate;
 // GLForm1.M_Refresh := TRUE;
   // GLForm1.GLSceneViewer1.invalidate;
end;

procedure TScriptForm.ADDNODE(INTENSITY, R,G,B,A: byte);
var
  lNode: integer;
begin
 //writeln(inttostr(intensity)+' '+inttostr(R)+' '+  inttostr(G)+' '+inttostr(B)+' '+inttostr(A));
  lNode := CLUTForm.AddColorNode(Intensity);
  if lNode < 0 then
    exit;
  CHANGENODE(lNode, INTENSITY, R,G,B,A);
end;

procedure TScriptForm.CONTRASTMINMAX(MIN,MAX: single);
var
 x,n: single;
begin
  //writeln(floattostr(MIN)+'x'+floattostr(Max));
     if MIN < Max then begin
        n := MIN;
        x := MAX;
     end else begin
         n := MAX;
         x := MIN;
     end;
     //CLUTForm.LUTdrop.SetFocus;
     //CLUTForm.MaxEdit.GetLimitedValue(x);
 //    CLUTForm.MaxEdit.value := x;
 //   CLUTFOrm.MinEdit.value := n;
 //   CLUTFORM.MaxEdit.value := x;

          gCLUTrec.min := n;
        gCLUTrec.max := x;
   CLUTform.MinMax(n,x);
    RenderUpdate;
    //CLUTFORM.MinEditChange(nil);
    //CLUTFORM.MaxEditChange(nil);
end;


procedure TScriptForm.CLIP (DEPTH: single);
begin
  //ClipForm.ClipTrack.Position := round(Depth * ClipForm.ClipTrack.Max);
  //GLForm1.SetViewerClipPlane(ClipForm.ClipTrack.position);
  GLForm1.SetViewerClipPlane(round(Depth * ClipForm.ClipTrack.Max));
end;

procedure TScriptForm.CLIPAZIMUTHELEVATION (DEPTH,AZI,ELEV: single);
begin
  //GLForm1.SetViewerClipPlaneAE (round(Depth * ClipForm.ClipTrack.Max),round(AZI),round(ELEV));
  //A := round(AZI);
  //E := round(Elev);;
    GLForm1.SetViewerClipPlaneAE (round(Depth * ClipForm.ClipTrack.Max),round(AZI),round(Elev));

end;


procedure TScriptForm.ORTHOVIEW (X,Y,Z: single);
begin
  gOrthoX := X;
  gOrthoY := Y;
  gOrthoZ := Z;
 view2D;
end;

procedure TScriptForm.BACKCOLOR (R,G,B: byte);
begin
  gPrefs.BackgroundColor :=R+ G shl 8 + B shl 16;
  GLForm1.GLSceneViewer1.Buffer.BackgroundColor :=  gPrefs.BackgroundColor;
  viewXD;
end;

procedure TScriptForm.CUTOUT (L,A,S,R,P,I: single);
var
  lMax: integer;
begin
//Caption := (floattostr(L)+'x'+ floattostr(A)+'x'+floattostr(S)+':'+floattostr(R)+'x'+ floattostr(P)+'x'+floattostr(I));
//exit;
  lMax := CutoutForm.XTrackBar.Max;
  CutoutForm.XTrackBar.Position := round(L*lMax);
  CutoutForm.X2TrackBar.Position := round(R*lMax);
  CutoutForm.YTrackBar.Position := round(A*lMax);
  CutoutForm.Y2TrackBar.Position := round(P*lMax);
  CutoutForm.ZTrackBar.Position := round(S*lMax);
  CutoutForm.Z2TrackBar.Position := round(I*lMax);
  view3D;
end;

procedure TScriptForm.MAXIMUMINTENSITY (MIP_ON: boolean);
begin
  GLForm1.MIPMenu.Checked := MIP_ON;
  GLForm1.MIPChange(nil);
  view3D;
end;

procedure TScriptForm.VIEWAXIAL (STD: boolean);
begin
  if STD then
    GLForm1.Axial1Click(nil)
  else
    GLForm1.Axial2Click(nil);
  view3D;
end;

procedure TScriptForm.VIEWCORONAL (STD: boolean);
begin
  if STD then
   GLForm1.Coronal1Click(nil)
  else
   GLForm1.Coronal2Click(nil);
  view3D;
end;

procedure TScriptForm.VIEWSAGITTAL (STD: boolean);
begin
  if STD then
   GLForm1.Sagittal1Click(nil)
  else
   GLForm1.Sagittal2Click(nil);
  view3D;
end;

procedure TScriptForm.PERSPECTIVE (USEPERSPECTIVE: boolean);
begin
  GLForm1.PerspectiveMenu.checked := USEPERSPECTIVE;
GLForm1.PerspectiveMenuClick(nil);

(*
  gPrefs.Perspective := USEPERSPECTIVE;
  GLForm1.PerspectiveMenu.checked := USEPERSPECTIVE;
    if gPrefs.Perspective then
    GLForm1.GLCamera1.CameraStyle := csPerspective
  else
    GLForm1.GLCamera1.CameraStyle := csOrthogonal;
  view3D; *)
end;

procedure TScriptForm.FRAMEVISIBLE (VISIBLE: boolean);
begin
  GLForm1.Frame.Visible := VISIBLE;
  GLForm1.FrameMenu.Checked := VISIBLE;
  view3D;
end;

procedure TScriptForm.VIDEOSTART (lFilename: string; lFPS: integer; lDefaultCodec: boolean);
var
  lF: string;
begin
{$IFNDEF FPC}
{$IFDEF ENABLEAVI}
  VIDEOEND;//save any previous recording
  GLForm1.AVIRecorder1.Height := GLForm1.GLSceneViewer1.Height;
  GLForm1.AVIRecorder1.Width := GLForm1.GLSceneViewer1.Width;
  if lFPS > 0 then
    GLForm1.AVIRecorder1.FPS := lFPS
  else
    GLForm1.AVIRecorder1.FPS := 20;
  if lDefaultCodec then
    GLForm1.AVIRecorder1.compressor :=  acDefault
  else
    GLForm1.AVIRecorder1.compressor := acShowDialog;
  lF := lFilename;
  if UpCaseExt(lF) <> '.AVI'  then
        lF := lF + '.avi';
  EnsureDirExists(lF);
  GLForm1.AVIRecorder1.Filename := lF;
  GLForm1.AVIRecorder1.Tag := 0;
  if not GLForm1.AVIRecorder1.CreateAVIFile then Exit;
{$ENDIF}
{$ENDIF}
end;

procedure TScriptForm.VIDEOCAPTUREFRAME;
begin
{$IFNDEF FPC}
{$IFDEF ENABLEAVI}
  FinishRender;
  GLForm1.AVIRecorder1.AddAVIFrame;
  GLForm1.AVIRecorder1.Tag := GLForm1.AVIRecorder1.Tag+1;
{$ENDIF}
{$ENDIF}
end;

procedure TScriptForm.VIDEOEND;
begin
{$IFNDEF FPC}
{$IFDEF ENABLEAVI}
  if not GLForm1.AVIRecorder1.Recording then
    exit;
  if GLForm1.AVIRecorder1.Tag < 1 then //no video
    GLForm1.AVIRecorder1.CloseAVIFile(true{UserAbort})
  else
    GLForm1.AVIRecorder1.CloseAVIFile(false{UserAbort});
{$ENDIF}
{$ENDIF}
end;

procedure TScriptForm.PSScript1Compile(Sender: TPSScript);
begin
Sender.AddMethod(Self, @TScriptForm.Writeln,'procedure Writeln(Str: string);');

Sender.AddMethod(Self, @TScriptForm.AZIMUTH, 'procedure AZIMUTH (DEG: integer)');
Sender.AddMethod(Self, @TScriptForm.AZIMUTHELEVATION, 'procedure AZIMUTHELEVATION (AZI, ELEV: integer)');
Sender.AddMethod(Self, @TScriptForm.BACKCOLOR, 'procedure BACKCOLOR (R,G,B: byte)');
Sender.AddMethod(Self, @TScriptForm.CAMERADISTANCE, 'procedure CAMERADISTANCE (Z: single)');
Sender.AddMethod(Self, @TScriptForm.CHANGENODE, 'procedure CHANGENODE(INDEX, INTENSITY, R,G,B,A: byte)');
Sender.AddMethod(Self, @TScriptForm.CLIP, 'procedure CLIP (DEPTH: single)');
Sender.AddMethod(Self, @TScriptForm.CLIPAZIMUTHELEVATION, 'procedure CLIPAZIMUTHELEVATION (DEPTH,AZI,ELEV: single)');
Sender.AddMethod(Self, @TScriptForm.CLIPFORMVISIBLE, 'procedure CLIPFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.COLORBARCOORD, 'procedure COLORBARCOORD (L,T,R,B: single)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYLOAD,'function OVERLAYLOAD(lFilename: string): integer');
Sender.AddMethod(Self, @TScriptForm.LOADDTI,'function LOADDTI(lFAFilename: string): integer');
Sender.AddMethod(Self, @TScriptForm.ADDNODE,'procedure ADDNODE(INTENSITY, R,G,B,A: byte)');
Sender.AddMethod(Self, @TScriptForm.COLORBARFORMVISIBLE,'procedure COLORBARFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.COLORBARTEXT,'procedure COLORBARTEXT (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.COLORBARVISIBLE,'procedure COLORBARVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.COLORNAME,'procedure COLORNAME(Filename: string)');
Sender.AddMethod(Self, @TScriptForm.CONTRASTFORMVISIBLE,'procedure CONTRASTFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.CONTRASTMINMAX,'procedure CONTRASTMINMAX(MIN,MAX: single)');
Sender.AddMethod(Self, @TScriptForm.CUTOUT,'procedure CUTOUT (L,A,S,R,P,I: single)');
Sender.AddMethod(Self, @TScriptForm.CUTOUTFORMVISIBLE,'procedure CUTOUTFORMVISIBLE (VISIBLE: boolean)');

Sender.AddMethod(Self, @TScriptForm.MEDIANSMOOTH,'procedure MEDIANSMOOTH');//new
Sender.AddMethod(Self, @TScriptForm.EDGEDETECT,'procedure EDGEDETECT (lThresh: single; lDilateCycles: integer)');//new
Sender.AddMethod(Self, @TScriptForm.DECIMATE,'procedure DECIMATE (lPercent: integer)');//new
Sender.AddMethod(Self, @TScriptForm.ELEVATION,'procedure ELEVATION (DEG: integer)');
Sender.AddMethod(Self, @TScriptForm.FRAMEVISIBLE,'procedure FRAMEVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.LOADIMAGE,'procedure LOADIMAGE(lFilename: string)');
Sender.AddMethod(Self, @TScriptForm.MAXIMUMINTENSITY,'procedure MAXIMUMINTENSITY (MIP_ON: boolean)');
Sender.AddMethod(Self, @TScriptForm.MODALMESSAGE,'procedure MODALMESSAGE(STR: string)');
Sender.AddMethod(Self, @TScriptForm.MODALMESSAGEX,'function MODALMESSAGEX(STR: string): boolean');

Sender.AddMethod(Self, @TScriptForm.MODELESSMESSAGE,'procedure MODELESSMESSAGE(STR: string)');
Sender.AddMethod(Self, @TScriptForm.MOSAIC,'procedure MOSAIC(Str: string)');
Sender.AddMethod(Self, @TScriptForm.MOSAICFORMVISIBLE,'procedure MOSAICFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.ORTHOVIEW,'procedure ORTHOVIEW (X,Y,Z: single)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYCLOSEALL,'procedure OVERLAYCLOSEALL');
Sender.AddMethod(Self, @TScriptForm.OVERLAYCOLORNAME,'procedure OVERLAYCOLORNAME(lOverlay: integer; lFilename: string)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYCOLORNUMBER,'procedure OVERLAYCOLORNUMBER(lOverlay,lLUTIndex: integer)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYFORMVISIBLE,'procedure OVERLAYFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYLOADSMOOTH,'procedure OVERLAYLOADSMOOTH (SMOOTH: boolean);');
Sender.AddMethod(Self, @TScriptForm.OVERLAYCOLORFROMZERO,'procedure OVERLAYCOLORFROMZERO (FROMZERO: boolean);');
Sender.AddMethod(Self, @TScriptForm.OVERLAYMASKEDBYBACKGROUND,'procedure OVERLAYMASKEDBYBACKGROUND (MASK: boolean)'); //new
Sender.AddMethod(Self, @TScriptForm.OVERLAYMINMAX,'procedure OVERLAYMINMAX (lOverlay: integer; lMin,lMax: single)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYTRANSPARENCYONBACKGROUND,'procedure OVERLAYTRANSPARENCYONBACKGROUND(lPct: integer)');
Sender.AddMethod(Self, @TScriptForm.OVERLAYTRANSPARENCYONOVERLAY,'procedure OVERLAYTRANSPARENCYONOVERLAY(lPct: integer)');
Sender.AddMethod(Self, @TScriptForm.PERSPECTIVE,'procedure PERSPECTIVE (USEPERSPECTIVE: boolean)');
Sender.AddMethod(Self, @TScriptForm.RESETDEFAULTS,'procedure RESETDEFAULTS');
Sender.AddMethod(Self, @TScriptForm.SAVEBMP,'procedure SAVEBMP(lFilename: string)');
Sender.AddMethod(Self, @TScriptForm.SCRIPTFORMVISIBLE,'procedure SCRIPTFORMVISIBLE (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.SETCOLORTABLE,'procedure SETCOLORTABLE(TABLENUM: integer)');
Sender.AddMethod(Self, @TScriptForm.SLICETEXT,'procedure SLICETEXT (VISIBLE: boolean)');
Sender.AddMethod(Self, @TScriptForm.VIEWAXIAL,'procedure VIEWAXIAL (STD: boolean)');
Sender.AddMethod(Self, @TScriptForm.VIEWCORONAL,'procedure VIEWCORONAL (STD: boolean)');
Sender.AddMethod(Self, @TScriptForm.VIEWSAGITTAL,'procedure VIEWSAGITTAL (STD: boolean)');
Sender.AddMethod(Self, @TScriptForm.WAIT,'procedure WAIT(MSEC: integer)');

Sender.AddMethod(Self, @TScriptForm.VIDEOSTART,'procedure VIDEOSTART(lFilename: string; lFPS: integer; lDefaultCodec: boolean)');
Sender.AddMethod(Self, @TScriptForm.VIDEOCAPTUREFRAME,'procedure VIDEOCAPTUREFRAME');
Sender.AddMethod(Self, @TScriptForm.VIDEOEND,'procedure VIDEOEND');

end;

procedure TScriptForm.Compile1Click(Sender: TObject);

var
  i: integer;
  Messages: string;
  compiled: boolean;
begin
  Memo2.Lines.Clear;
  PSScript1.Script.Text := Memo1.Lines.GetText;
  Compiled := PSScript1.Compile;
  for i := 0 to PSScript1.CompilerMessageCount -1 do
    Writeln( PSScript1.CompilerMessages[i].MessageToString);
    {Messages := Messages +
                ce.CompilerMessages[i].MessageToString +
                #13#10;  }
  if Compiled then
    Writeln('Successfully Compiled Script');
  if Compiled then begin
    if PSScript1.Execute then
      Writeln('Succesfully Executed')
    else
      Writeln('Error while executing script: '+
                  PSScript1.ExecErrorToString);
    VideoEnd;
  end;
end;




procedure TScriptForm.FormCreate(Sender: TObject);
begin
  fn := '';
  gchanged := False;
  Memo1.Lines.Text := 'Program Sample;'#13#10'Begin'#13#10'MOSAIC(''0.25 0.5; 0.75 C 0.5'');'#13#10'End.';
  FillMRU (gPrefs.PrevScriptName, ScriptDir+pathdelim,kScriptExt,False);
  UpdateMRU;
  OpenMRU(nil);
  OpenDialog1.InitialDir := ScriptDir;
  SaveDialog1.InitialDir := ScriptDir;
 {$IFDEF Darwin}
        {$IFNDEF LCLgtk} //only for Carbon compile
         Stop1.ShortCut := ShortCut(Word('H'), [ssMeta]);
         Compile1.ShortCut := ShortCut(Word('R'), [ssMeta]);
 {$ENDIF}
 {$ENDIF}
end;

function TScriptForm.SaveTest: Boolean;
begin
  result := True;
(*  if changed then
  begin
    case MessageDlg('File is not saved, save now?', mtWarning, mbYesNoCancel, 0) of
      mrYes:
        begin
          Save1Click(nil);
          Result := not changed;
        end;
      mrNo: Result := True;
    else
      Result := False;
    end;
  end
  else
    Result := True;
*)
end;

procedure TScriptForm.OpenScript(lFilename: string);
begin
  GLForm1.StopTimers;
  ScriptForm.Stop1Click(nil);
  if not fileexists (lFilename) then begin
    Showmessage('Can not find '+lFilename);
    exit;
  end;
    Memo1.Lines.LoadFromFile(lFileName);
    gchanged := False;

    Memo2.Lines.Clear;
    fn := lFileName;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
end;

procedure TScriptForm.Open1Click(Sender: TObject);
var
   lS: string;
begin
  if not SaveTest then
    exit;
  lS :=  GetCurrentDir;
  if not OpenDialog1.Execute then
    exit;
   SetCurrentDir(lS);
  OpenScript(OpenDialog1.FileName);
(*    Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    gchanged := False;
    Memo2.Lines.Clear;
    fn := OpenDialog1.FileName;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;*)
end;

procedure TScriptForm.Save1Click(Sender: TObject);
begin
  if fn = '' then
  begin
    Saveas1Click(nil);
  end
  else
  begin
    Memo1.Lines.SaveToFile(fn);
    gchanged := False;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
  end;
end;

procedure TScriptForm.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.FileName := '';
  if SaveDialog1.Execute then
  begin
    fn := SaveDialog1.FileName;
    Memo1.Lines.SaveToFile(fn);
    gchanged := False;
    Add2MRU(gPrefs.PrevScriptName,fn);
	  UpdateMRU;
  end;
end;

procedure TScriptForm.Memo1Change(Sender: TObject);
begin
     inherited;
  gchanged := True;
end;

procedure TScriptForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := SaveTest;
end;

procedure TScriptForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TScriptForm.Stop1Click(Sender: TObject);
begin
  if PSScript1.Running then
    PSScript1.Stop;
end;

procedure TScriptForm.New1Click(Sender: TObject);
begin
  GLForm1.StopTimers;
  ScriptForm.Stop1Click(nil);
  if not SaveTest then
    exit;

  Memo1.Lines.Text := 'Program IFSTest;'#13#10'Begin'#13#10'End.';
  Memo2.Lines.Clear;
  fn := '';
end;

procedure TScriptForm.Copy1Click(Sender: TObject);
begin
  if length(Memo1.SelText) < 1 then
    Memo1.SelectAll;
  Clipboard.AsText := Memo1.SelText;
end;



procedure CleanStr (var lStr: string);
//remove symbols, set upcase...
var
  lLen,lPos: integer;
  lS: string;
begin
  lLen := length(lStr);
  if lLen < 1 then
    exit;
  lS := '';
  for lPos := 1 to lLen do
    if lStr[lPos] in ['0'..'9','a'..'z','A'..'Z'] then
      lS := lS + upcase(lStr[lPos]);
    lStr := lS;
end;

procedure TScriptForm.Readline(var lPosIn: integer);
var
  lS: string;
  lCh: char;
  lPos,lLen: integer;
begin
  lPos := lPosIn;
  lLen := length(Memo1.Lines.GetText);
  lS := '';
  //fx(lPos,lLen);
  while (lPos < lLen) and ((Memo1.Text[lPos] <> #10) or (lS = '')) do begin
     lCh := upcase(Memo1.Text[lPos]);
     //showmessage(lCh);
     if (lCh in ['A'..'Z']) then begin
      lS := lS + lCh;
     end;
     inc(lPos);
  end;
  if (lS = 'BEGIN') then
    lPosIn := lPos;
  //caption := lS;
end;

procedure TScriptForm.AdjustSelText;
var
  lPos: integer;
begin
  lPos := Memo1.SelStart;
  Memo1.SelLength := 0;
  if lPos < 1 then
    exit;
  while (lPos > 0) and (Memo1.Text[lPos] <> #10) do
    dec(lPos);
  //next move text to after BEGIN statement
  Readline(lPos);
  Memo1.SelStart := lPos;
end;

procedure TScriptForm.InsertCommand(Sender: TObject);
var
  lStr : string;
  lParams,lLoop,lType: integer;//1=boolean,2=integer,3=float,4=string[filename]
begin
  lType := (Sender as TMenuItem).Tag;
  lStr := (Sender as TMenuItem).Hint;
  if lStr <> '' then begin
          Memo2.Lines.Clear;

          Memo2.Lines.Add(lStr);
  end;
  lStr := (Sender as TMenuItem).Caption;

  CleanStr(lStr);
  if lType <> 0 then begin
    lStr := lStr+'(';
    lParams := 1;
    if lType > 9 then begin //e.g. 31 means three boolean values...
      lParams := lType div 10;
      lType := lType - (lParams*10);
    end;
    for lLoop := 1 to lParams do begin
     case lType of
      1:  lStr := lStr +'true';
      2:  lStr := lStr +'1';
      3:  begin
            if lLoop <= 3 then //for Cutout view, we need six values - make them different so this is a sensible cutout
              lStr := lStr +'0.5'
            else
              lStr := lStr +'1.0';
        end;
      4:  lStr := lStr +'''filename''';
      5: lStr := lStr + '''0.2 0.4 0.6; 0.8 S 0.5''';
      6: begin //byte
            if lLoop <= 3 then //for Cutout view, we need six values - make them different so this is a sensible cutout
              lStr := lStr +'1'
            else
              lStr := lStr +'255';
        end;
      else lStr := lStr + '''?''';
     end;
     if lLoop < lParams then
        lStr := lStr+', ';
    end;//for each loop
    lStr := lStr + ');';
  end else //no params
    lStr := lStr + ';';
  Clipboard.AsText := lStr;
  AdjustSelText;
  Memo1.SelText := (lStr)+ #13#10;
end;

initialization
{$IFDEF FPC}
    {$I scriptengine.lrs}
{$ENDIF}
end.
